# Copyright (c) 2000-2012, JPackage Project
# All rights reserved.
#
# Redistribution and use in source and binary forms, with or without
# modification, are permitted provided that the following conditions
# are met:
#
# 1. Redistributions of source code must retain the above copyright
#    notice, this list of conditions and the following disclaimer.
# 2. Redistributions in binary form must reproduce the above copyright
#    notice, this list of conditions and the following disclaimer in the
#    documentation and/or other materials provided with the
#    distribution.
# 3. Neither the name of the JPackage Project nor the names of its
#    contributors may be used to endorse or promote products derived
#    from this software without specific prior written permission.
#
# THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
# "AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
# LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR
# A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT
# OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL,
# SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT
# LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS OF USE,
# DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON ANY
# THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT
# (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE
# OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.

%bcond_without repolib

%define section free

%global wsmdver 2.0

%define reltag _MR1_redhat_2
%define namedreltag -MR1-redhat-2
%global namedversion 1.0%{?namedreltag}

Name:           sun-ws-metadata-2.0-api
Version:        1.0.MR1
Release:        12%{?reltag}%{?dist}.4
Epoch:          0
Summary:        Web Services Metadata 2.0 MR API
License:        CDDL
Group:          Development/Libraries/Java
URL:            https://jsr250.dev.java.net/
Source0:        http://download.java.net/maven/1/javax.jws/java-sources/jsr181-api-1.0-MR1-sources.jar
Source1:        http://download.java.net/maven/1/javax.jws/poms/jsr181-api-1.0-MR1.pom
Source2:        CDDLv1.0.html
Source3:        sun-ws-metadata-2.0-api-build.properties
Source4:        sun-ws-metadata-2.0-api-build.xml
Patch0:         %{name}-build_xml.patch
Patch1:         jsr181-api-pom.patch
Provides:       jsr181-api = 1.0-MR1
Provides:       ws_metadata_api = 0:%{wsmdver}
Provides:       ws_metadata_2_0_api = 0:%{version}-%{release}
Requires(post): jpackage-utils
Requires(post): %{_sbindir}/update-alternatives
Requires(postun): jpackage-utils
Requires(preun): %{_sbindir}/update-alternatives
Requires:       jpackage-utils
BuildRequires:  maven2-plugin-deploy
BuildRequires:  ant
BuildRequires:  java-devel >= 0:1.5.0
BuildRequires:  jboss-parent
BuildRequires:  jpackage-utils
BuildArch:      noarch
BuildRoot:      %{_tmppath}/%{name}-%{version}-%{release}-root

%description
Web Services Metadata for the Java Platform 2.0 Maintenance Release
according to JSR-181.

This is JSR-181 MR1 in fact, which changed its version from 1.0 to 2.0.

%package javadoc
Summary:        Javadoc for jsr181-api
Group:          Development/Documentation
Provides:       ws-metadata-javadoc = 0:%{wsmdver}
Requires:       jpackage-utils

%description javadoc
%{summary}.

%if %with repolib
%package repolib
Summary:        Artifacts to be uploaded to a repository library
Group:          Development/Libraries/Java

%description repolib
Artifacts to be uploaded to a repository library.
This package is not meant to be installed but so its contents
can be extracted through rpm2cpio.
%endif

%prep
%setup -q -c 
%{__mkdir_p} src/java
%{__mv} javax src/java
%{__cp} -p %{SOURCE1} jsr181-api-1.0-MR1.pom
%{__cp} -p %{SOURCE2} .
%{__cp} -p %{SOURCE3} build.properties
%{__cp} -p %{SOURCE4} build.xml

%patch0 -p0 -b .sav0
%patch1 -p0 -b .sav1

%build
export CASSPATH=
export OPT_JAR_LIST=:
%{ant} -Dbuild.sysclasspath=last release

%install
%{__rm} -rf %{buildroot}

# jars
%{__mkdir_p} %{buildroot}%{_javadir}
%{__cp} -p jws.jar %{buildroot}%{_javadir}/jsr181-api-%{namedversion}.jar
(cd %{buildroot}%{_javadir} && for jar in *-%{namedversion}*; do %{__ln_s} ${jar} `/bin/echo ${jar} | %{__sed} "s|-%{namedversion}||g"`; done)

/bin/touch %{buildroot}%{_javadir}/ws_metadata_api.jar
/bin/touch %{buildroot}%{_javadir}/ws_metadata_2_0_api.jar

# poms
%{__mkdir_p} %{buildroot}%{_mavenpomdir}
%{__cp} -p jsr181-api-1.0-MR1.pom %{buildroot}%{_mavenpomdir}/JPP-jsr181-api.pom
%add_to_maven_depmap javax.jws jsr181-api %{namedversion} JPP jsr181-api
%{__mv} %{buildroot}%{_mavendepmapfragdir}/%{name} %{buildroot}%{_mavendepmapfragdir}/jsr181-api

# javadoc
%{__mkdir_p} %{buildroot}%{_javadocdir}/jsr181-api-%{namedversion}
%{__cp} -pr build/release/docs/javadocs/* %{buildroot}%{_javadocdir}/jsr181-api-%{namedversion}
ln -s jsr181-api-%{namedversion} %{buildroot}%{_javadocdir}/jsr181-api

%if %with repolib
%{_bindir}/mvn-jpp deploy:deploy-file -Dmaven.repository.local=`pwd`/.m2/repository -Dfile=%{buildroot}%{_javadir}/jsr181-api-%{namedversion}.jar \
-DpomFile=%{buildroot}%{_mavenpomdir}/JPP-jsr181-api.pom \
-Durl=file://%{buildroot}%{_javadir}/repository.jboss.com/maven2-brew -DrepositoryId=jboss-releases
%endif

%clean
%{__rm} -rf %{buildroot}

%post
%{_sbindir}/update-alternatives --install %{_javadir}/ws_metadata_2_0_api.jar ws_metadata_2_0_api %{_javadir}/jsr181-api.jar 20000
%{_sbindir}/update-alternatives --install %{_javadir}/ws_metadata_api.jar ws_metadata_api %{_javadir}/jsr181-api.jar 20000
%update_maven_depmap

%preun
if [ "$1" = "0" ]; then
    %{_sbindir}/update-alternatives --remove ws_metadata_2_0_api %{_javadir}/jsr181-api.jar
    %{_sbindir}/update-alternatives --remove ws_metadata_api %{_javadir}/jsr181-api.jar
fi

%postun
%update_maven_depmap

%files
%defattr(0644,root,root,0755)
%doc CDDLv1.0.html
%ghost %{_javadir}*/ws_metadata_2_0_api.jar
%ghost %{_javadir}*/ws_metadata_api.jar
%{_javadir}*/jsr181-api-%{namedversion}.jar
%{_javadir}*/jsr181-api.jar
%ghost %{_javadir}*/ws_metadata_2_0_api.jar
%ghost %{_javadir}*/ws_metadata_api.jar
%{_mavenpomdir}/JPP-jsr181-api.pom
%{_mavendepmapfragdir}/jsr181-api

%files javadoc
%defattr(0644,root,root,0755)
%{_javadocdir}/jsr181-api-%{namedversion}
%{_javadocdir}/jsr181-api

%if %with repolib
%files repolib
%defattr(0644,root,root,0755)
%dir %{_javadir}*
%exclude %dir %{_javadocdir}
%{_javadir}*/repository.jboss.com
%endif

%changelog
* Sat Sep 01 2012 Paul Gier <pgier@redhat.com> - 0:1.0.MR1-12_MR1_redhat_2.4
- Update pom patch for eap 6.0.1

* Tue Aug 14 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.MR1-12_MR1_redhat_2.3
- Rebuild unsigned

* Thu Jul 19 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.MR1-12_MR1_redhat_1.2
- Rebuild using cache signing

* Mon Mar 26 2012 Fernando Nasser <fnasser@redhat.com> - 0:1.0.MR1-12_MR1_redhat_1.1
- Rebuild using cache signing

* Wed Feb 22 2012 David Walluck <dwalluck@redhat.com> 0:1.0.MR1-12
- add pom patch
- fix jar name
- fix doc location
- javadoc requires jpackage-utils
- remove gcj_support
- remove buildmagic repo

* Mon Apr 11 2011 David Walluck <dwalluck@redhat.com> 0:1.0.MR1-11
- own alternatives links
- fix repolib option
- fix maven deps
- fix dir ownership

* Fri Apr 08 2011 Martha Benitez <mbenitez@redhat.com> - 0:1.0.MR1-10.1
- Fix version to include MR1

* Thu Mar 10 2011 Hui Wang <huwang@redhat.com> 0:1.0.MR1-10
- Fix %%repodir macros

* Thu Mar 10 2011 Hui Wang <huwang@redhat.com> 0:1.0.MR1-9
- Fix version

* Thu Dec 09 2010 Hui Wang <huwang@redhat.com> 0:1.0.MR1-8
- Add upload.sh and content of maven2-brew to repolib
- Fix %%files for signed jars

* Wed Sep 08 2010 David Walluck <dwalluck@redhat.com> 0:1.0.MR1-7
- rebuild

* Wed Sep 08 2010 David Walluck <dwalluck@redhat.com> 0:1.0.MR1-6
- fix alternatives
- fix maven support
- fix POM name
- add jws.jar symlink
- fix GCJ support
- fix javadoc
- fix repolib

* Fri May 07 2010 Martha Benitez <mbenitez@redhat.com> - 0:1.0.MR1-5.1
- rebuilt

* Tue Apr 06 2010 Hui Wang <huwang@redhat.com> - 0:1.0.MR1-5
- Rebuild
- Change BR: BuildRequires:  java-devel = 0:1.5.0  to BR: BuildRequires:  java-devel >= 0:1.5.0
- Change BR: export JAVA_HOME=/usr/lib/jvm/java-1.5.0 to BR: export JAVA_HOME=/usr/lib/jvm/java-1.6.0

* Fri Nov 20 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.MR1-4
- Add manifest patch to repolib

* Fri Nov 20 2009 Martha Benitez <mbenitez@redhat.com> - 0:1.0.MR1-3
- Add repolib
- Add patch to fill in manifest.mf in jar

* Mon Dec 08 2008 Will Tatam <will.tatam@red61.com> 1.0.MR1-2
- Auto rebuild for JPackage 5 in mock

* Thu Nov 08 2007 Ralph Apel <r.apel at r-apel.de> - 0:1.0.MR1-1jpp
- First release

